﻿using System;
using System.Net;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Regions;
using RadRibbonBarPrism.Common;
using Microsoft.Practices.Prism.Commands;

namespace RadRibbonBarPrism.ModuleA
{
    public class ModuleA : IModule
    {
        public ModuleA(IRegionManager regionManager)
        {
            if (regionManager == null)
            {
                throw new ArgumentNullException("regionManager");
            }

            RegionManager = regionManager;
        }

        public IRegionManager RegionManager { get; set; }

        public void Initialize()
        {
            ModuleDefinition module = new ModuleDefinition();
            module.ModuleName = "Module A";
            module.RegionName = Regions.ModuleANavigationMenu;

            GroupDefinition group = new GroupDefinition();
            group.GroupName = "Module A Group";
            module.GroupDefinitions.Add(group);

            ActionDefinition action = new ActionDefinition();
            action.Name = "Click Me";
            action.Command = new DelegateCommand<object>(o => System.Windows.Forms.MessageBox.Show("Module A Command Executed"));
            group.ActionDefinitions.Add(action);

            RegionManager.AddToRegion(Regions.RibbonRegion, module);
        }
    }
}
