﻿using System;
using System.Net;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Regions;
using RadRibbonBarPrism.Common;
using Microsoft.Practices.Prism.Commands;
using System.Windows.Forms;

namespace RadRibbonBarPrism.ModuleB
{
    public class ModuleB : IModule
    {
        public ModuleB(IRegionManager regionManager)
        {
            if (regionManager == null)
            {
                throw new ArgumentNullException("regionManager");
            }

            RegionManager = regionManager;
        }

        public IRegionManager RegionManager { get; set; }

        public void Initialize()
        {
            // Inject a group inside the nested region of the module A
            GroupDefinition group = new GroupDefinition();
            group.GroupName = "Module AB Group";

            ActionDefinition action = new ActionDefinition();
            action.Name = "Click Me";
            action.Command = new DelegateCommand<object>(o => MessageBox.Show("Module AB Command Executed"));
            group.ActionDefinitions.Add(action);

            RegionManager.AddToRegion(Regions.ModuleANavigationMenu, group);



            // Inject the menu of the module itself
            ModuleDefinition module = new ModuleDefinition();

            module.ModuleName = "Module B";

            GroupDefinition group2 = new GroupDefinition();
            group2.GroupName = "Module B Group";
            module.GroupDefinitions.Add(group2);
            
            ActionDefinition action2 = new ActionDefinition();
            action2.Name = "Click Me";
            action2.Command = new DelegateCommand<object>(o => MessageBox.Show("I'm a split button"));
            group2.ActionDefinitions.Add(action2);

            ActionDefinition subAction = new ActionDefinition();
            subAction.Name = "I'm sub action 1, click Me";
            subAction.Command = new DelegateCommand<object>(o => MessageBox.Show("Module B Sub Command 1 Executed"));
            action2.SubActions.Add(subAction);

            ActionDefinition subAction2 = new ActionDefinition();
            subAction2.Name = "I'm sub action 2, click Me";
            subAction2.Command = new DelegateCommand<object>(o => MessageBox.Show("Module B Sub Command 2 Executed"));
            action2.SubActions.Add(subAction2);

            RegionManager.AddToRegion(Regions.RibbonRegion, module);
        }
    }
}
