﻿using System;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.Specialized;
using RadRibbonBarPrism.Common;
using Microsoft.Practices.Prism.Regions;

namespace RadRibbonBarPrism.Adapters
{
	public class RibbonAdapter : RegionAdapterBase<RadRibbonBar>
	{
		public RibbonAdapter(IRegionBehaviorFactory regionBehaviorFactory)
			: base(regionBehaviorFactory)
		{ }

		protected override void Adapt(IRegion region, RadRibbonBar regionTarget)
		{
			region.ActiveViews.CollectionChanged += (sender, args) =>
			{
				switch (args.Action)
				{
					case NotifyCollectionChangedAction.Add:
					foreach (ModuleDefinition module in args.NewItems)
					{
						RibbonAdapterHelper.AddModuleDefinition(module, regionTarget);
					}
					break;
					case NotifyCollectionChangedAction.Remove:
					foreach (ModuleDefinition module in args.OldItems)
					{
						RibbonAdapterHelper.RemoveModuleDefinition(module, regionTarget);
					}
					break;
				}

			};
		}



		protected override IRegion CreateRegion()
		{
			return new AllActiveRegion();
		}
	}
}
